#include <vector>
#include <algorithm>
#include <math.h>
#include <iostream>
#include <fstream>
#include <stdio.h>

typedef vector<double> VD;
typedef vector<int> VI;

bool dbl_eq (double a, double b) {
  //  if (fabs(a-b) < 0.00001) return true;
  //return false;
  return a == b;
}

void merge(VD &v, double x0, double x1)
{
  if (dbl_eq(x0, x1)) return;
  if (x0 > x1) swap(x0,x1);
  if (v.empty()) {
    v.push_back(x0);
    v.push_back(x1);
    return;
  }
  //int in = 0;
  bool isopen = false;
  VD r;
  int i = 0;
  int j = 0;
  while (1) {
    bool isend;
    bool bla = false;
    double m;
    if (i>=v.size()) {
      if (j>=2) break;
      if (j==0) { isend = false; m = x0; bla = true; }
      else if (j==1) { isend = true; m = x1; bla = true; }
      j++;
    } else {
      isend = (i&1) == 1;
      m = v[i];
      if (m < x1 && j == 1) isend = false;
      if (m > x0 && j == 0) {m = x0; j++; isend = false; bla = true; }
      if (m > x1 && j == 1) {m = x1; j++; isend = true; bla = true; }
    }
    if (isopen && isend) { r.push_back(m); isopen = false; }
    if (!isopen && !isend) { r.push_back(m); isopen = true; }
    if (!bla) i++;
  }
  v = r;
  /*  for (i = 0; i<r.size(); i++) {
    cout << r[i] << " ";
  }
  cout << endl;*/
}

struct rect {
  double x0, x1, y0, y1;
};

vector<rect> R;

void update(VI &v, double y)
{
  for (int i=0; i<R.size(); i++) {
    if (dbl_eq(y, R[i].y1)) {
      v.erase(find(v.begin(), v.end(), i));
    } else if (dbl_eq(y, R[i].y0)) v.push_back(i);
  }
}

double calc (VI &v, double y)
{
  /*cout << "calc y==" << y << endl;
  for (int i = 0; i<v.size(); i++) {
    cout << "calc: " << v[i] << " ";
  }
  cout << endl;*/

  double a = 0.0;
  VD d;
  for (int i=0; i<v.size(); i++) merge(d, R[v[i]].x0, R[v[i]].x1);
  /*for (int i = 0; i<d.size(); i++) {
    cout << "d: " << d[i] << " ";
  }
  cout << endl;*/

  for (int i=0; i<d.size(); i+=2) a += y * (d[i+1] - d[i]);
  return a;
}

int main()
{
  ifstream in("atlantis.in");
  int num = 0;
  int n;
  while (in >> n) {
    if (!n) break;
    ++num;
    R.clear();
    VD ys;
    VI xs;
    for (int i=0; i<n; i++) {
      struct rect r;
      in >> r.x0 >> r.y0 >> r.x1 >> r.y1;
      R.push_back(r);
      ys.push_back(r.y0);
      ys.push_back(r.y1);
    }
    sort(ys.begin(), ys.end());
    VD::iterator e = unique(ys.begin(), ys.end(), dbl_eq);
    ys.erase(e, ys.end());
    /*for (int i = 0; i<ys.size(); i++) {
      cout << ys[i] << " ";
    }
    cout << endl;*/
    update(xs, ys[0]);
    double area = 0.0;
    for (int i=1; i < ys.size(); i++) {
      double yd = ys[i] - ys[i-1];
      area += calc(xs, yd);
      update(xs, ys[i]);
    }
    // xs sollte leer sein
    cout << "Test case #" << num << endl;
    printf("Total explored area: %.2f\n\n", area);
  }
  return 0;
}
