#include <iostream>
#include <fstream>
#include <string>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <vector>

/*
struct author {
  string first;
  string last;

  bool operator < (const author& au) const {
    return last < au.last || last == au.last && first < au.first;
  }
  bool operator == (const author& au) const {
    return last == au.last && first == au.first;
  }
};

class CmpAu {
public:
  bool operator() (const author& au1, const author& au2) const {
    return au1 < au2;
  }

};
*/

typedef string author;

struct auitem {
  int au;
  int num ;

  bool operator <(const auitem& item) const {
    return num > item.num;
  }
};

const author erdos = "Erdos, P.";


typedef map<int, set<int> > successors;

int main()
{
  ifstream in("erdos.in");
  int n, p;
  int db = 0;
  while (in >> p >> n && (p || n)) {
    db++;
    string dummy;
    getline(in, dummy);
    list<int> pub;
    set<author> authors;
    map<author,int> author_indices;
    map<int,author> author_names;
    successors succs;

    authors.insert(erdos);
    author_indices[erdos]=0;
    author_names[0] = erdos;
    const int erdosindex=0;

    for (int i = 0; i < p; i++) {
      string line;
      getline(in, line);
      line = line.substr(0, line.find(":", 0)) + ",";
      //	cout << "0" << endl;
      unsigned begin = 0;
      // cout << line << endl;
      while (begin < line.length()) {
	// cout << "0.5" << endl;
	unsigned last = line.find(",", begin);
	// cout << "0.6" << endl;
	unsigned first = line.find(",", last + 1);
	//	string lastName(line.substr(begin, last - begin));
	//      string firstName(line.substr(last + 2, first - last - 2));
	//	author au = {firstName, lastName};
	// cout << "0.7" << " " << first << " " << last << endl;
	author au = line.substr(begin, first - begin);
	// cout << "0.8" << endl;
	int index;
	if (!authors.count(au)) {
	  index=authors.size();
	  authors.insert(au);
	  author_indices[au]=index;
	  author_names[index]=au;
	} else
	  index=author_indices[au];
	pub.push_back(index);
	begin = first + 2;
	// cout << "1" << endl;
      }
      while (!pub.empty()) {
	int au = pub.back();
	pub.pop_back();
	for (list<int>::iterator it = pub.begin(); it != pub.end(); it++) {
	  succs[au].insert(*it);
	  succs[*it].insert(au);
	  // cout << "2" << endl;
	}
      }
    }
    // cout << "3" << endl;
    cout << "Database #" << db << endl;
    for (int i = 0; i < n; i++) {
      string line;
      getline(in, line);
      // cout << "4" << endl;
      // unsigned index = line.find(",", 0);
      //      string last(line.substr(0, index));
      //string first(line.substr(index, string::npos));
      //      author dest = { first, last };
      author dest = line;
      int destindex;
      if (!authors.count(dest)) {
	destindex=authors.size();
	authors.insert(dest);
	author_indices[dest]=destindex;
	author_names[destindex]=dest;
      } else
	destindex=author_indices[dest];

      priority_queue<auitem> qu;
      auitem item = {destindex , 0};
      qu.push(item);
      set<int> visited;
      visited.insert(item.au);
      bool found = false;
      auitem founditem;
      while (!qu.empty()) {
	// cout << "5" << endl;
	auitem item = qu.top();
	qu.pop();
	if (item.au == erdosindex) {
	  found = true;
	  founditem = item;
	  break;
	}
	set<int> &s=succs[item.au];
	for (set<int>::iterator it = s.begin(); it != s.end(); it++) {
	  if (!visited.count(*it)) {
	    auitem newItem = { *it, item.num + 1 }; 
	    visited.insert(newItem.au);
	    qu.push(newItem);
	  }
	}
      }
      //      cout << dest.last << ", " << dest.first << ": ";
      cout << dest << ": ";
      if (found)
	cout << founditem.num << endl;
      else
	cout << "infinity" << endl;
    }
  }
  return 0;
    
}
