#include <iostream>
#include <fstream>
#include <set>

inline set<int> remove_some(const set<int> &avail, int x) {
  set<int> newavail=avail;
  newavail.erase(x);

  // cout << x << endl;

  int max=(int)avail.size();
  for (set<int>::iterator i=avail.begin(); 
       i!=avail.end(); i++) 

    if (*i!=x) {
      int index=*i;
      for (int j=0; j<=max; j++) {
	index-=x;

	if (index<=1)
	  break;
	
	if (index==x || !avail.count(index)) {
	  newavail.erase(*i);
	  // cout << *i << " erased, j=" << j << endl;
	  break;
	}
      }
    }

  return newavail;
}

bool winning_move_exists2(const set<int> &avail) {
  for (set<int>::iterator i=avail.begin(); 
       i!=avail.end(); i++) {
    set<int> avail1 = remove_some(avail, *i);
    bool success=true;
    for (set<int>::iterator j=avail1.begin(); 
	 j!=avail1.end() && success; j++) {
      set<int> avail2 = remove_some(avail1, *j);
      
      set<int> dummy;
      if (!winning_move_exists2(avail2))
	success=false;
    }

    if (success)
      return true;
  }

  return false;
}

bool winning_move_exists(const set<int> &avail, set<int> &winning_moves) {
  winning_moves.clear();

  for (set<int>::iterator i=avail.begin(); 
       i!=avail.end(); i++) {
    set<int> avail1 = remove_some(avail, *i);
    bool success=true;
    for (set<int>::iterator j=avail1.begin(); 
	 j!=avail1.end() && success; j++) {
      set<int> avail2 = remove_some(avail1, *j);
      
      set<int> dummy;
      if (!winning_move_exists2(avail2))
	success=false;
    }

    if (success)
      winning_moves.insert(*i);
  }

  return !winning_moves.empty();
}

int main() {
  int n, N=0;
  ifstream in("numbergame.in");
  while (in >> n && n) {
    set<int> avail;
    for (int i=0; i<n; i++) {
      int j;
      in >> j;
      avail.insert(j);
    }

    set<int> moves;
    cout << "Test Case #" << ++N << endl;
    if (winning_move_exists(avail, moves)) {
      cout << "The winning moves are: ";
      for (set<int>::iterator i=moves.begin();
	   i!=moves.end(); i++) {
	if (i!=moves.begin())
	  cout << " ";
	cout << *i;
      }
    } else {
      cout << "There's no winning move.";
      
    }
    cout << endl << endl;
  }
}
