#include <iostream>
#include <fstream>
#include <set>
#include <string>
#include <queue>
#include <map>
#include <vector>
#include <stdio.h>

struct depart{
  int time; 
  int train;
  int city;
};

struct item{
  int starttime;
  int endtime;
  int city;

  bool operator < (const item &i) const {
    return (endtime > i.endtime) ||
      ((endtime == i.endtime) &&
       (endtime-starttime > i.endtime-i.starttime));
       
  }
};

int main() {
  ifstream in("railroad.in");
  int C;
  int N=0;
  while (in>>C && C) {
    map<string, int> city_indices;
    vector<string> city_names;
    map<int,vector<depart> > departures;
    map<int,vector<depart> > trains;
    map<int,set<int> > trains_in_city;
    set<string> cities;
    string dummy;
    getline(in, dummy);
    for (int i=0; i<C; i++) {
      string s;
      getline(in, s);
      while (s.length()>0 && s[0]<=' ')
	s.erase(0,1);
      while (s.length()>0 && s[s.length()-1]<=' ')
	s.erase(s.length()-1,1);
      city_indices[s] = city_names.size();
      city_names.push_back(s);
      cities.insert(s);
    }
    int T;
    in >> T;
    for (int i=0; i<T; i++) {
      int n;
      in >> n;
      for (int j=0; j<n; j++) {
	depart d;
	in >> d.time;
	string s;
	getline(in, s);
	while (s.length()>0 && s[0]<=' ')
	  s.erase(0,1);
	while (s.length()>0 && s[s.length()-1]<=' ')
	  s.erase(s.length()-1,1);
	d.train = i;
	d.city = city_indices[s];
	departures[d.city].push_back(d);
	trains[d.train].push_back(d);
	trains_in_city[d.city].insert(i);
      }
    }
    int starttime;
    in >> starttime;
    getline(in, dummy);
    string start_city, end_city;
    getline(in, start_city);
    getline(in, end_city);

    priority_queue<item> pq;

    if (cities.count(start_city)) {
      int start=city_indices[start_city];
      vector<depart> startdeparts=departures[start];
      for (int i=0; i<startdeparts.size(); i++) {
	depart d=startdeparts[i];
	if (d.time>=starttime) {
	  item it;
	  it.starttime=d.time;
	  it.endtime=it.starttime;
	  it.city=d.city;
	  pq.push(it);
	}
      }
    }

    cout << "Scenario #" << ++N << endl;
    bool success=false;

    if (cities.count(end_city)) {
      int end=city_indices[end_city];

    while (!pq.empty()) {
      item it=pq.top();
      pq.pop();
      
      if (it.city==end) {
	printf("Departure %04d %s\n", it.starttime, start_city.c_str());
	printf("Arrival   %04d %s\n", it.endtime, city_names[it.city].c_str());
	success=true;
	break;
      }

      set<int> &trainset=trains_in_city[it.city];
      for (set<int>::iterator i=trainset.begin();
	   i!=trainset.end(); i++) {
	
	vector<depart> &train=trains[*i];
	bool insert=false;
	for (int j=0; j<train.size(); j++) {
	  depart d=train[j];
	  if (insert) {
	    item nit;
	    nit.starttime=it.starttime;
	    nit.endtime=d.time;
	    nit.city=d.city;
	    // cout << d.time << " " << city_names[d.city] << endl;
	    pq.push(nit);
	  } else if (d.time>=it.endtime)
	    insert=true;
	}
      }
    }
    }
    
    if (!success)
      cout << "No connection" << endl;
    cout << endl;
  }
}
