#include <iostream>
#include <fstream>
#include <vector>

vector<unsigned> primes;

#define m 10000

void build_primes() 
{
    bool sieve[m];
    for (int i=0; i<m; i++)
        sieve[i]=true;
    sieve[0]=false;
    sieve[1]=false;
    for (int i=2; i<m; i++)
        if (sieve[i])
            for (int j=2; j*i<m; j++)
                sieve[i*j]=false;
    
    for (int i=0; i<m; i++)
        if (sieve[i])
            primes.push_back((unsigned)i);
}


unsigned sum_of_digits(unsigned n) 
{
    unsigned sum=0;
    while (n) 
    {
//        cout << n%10 << endl;
        
        sum+=n%10;
        n/=10;
    }
    return sum;
}


unsigned sum_of_factors(unsigned n, unsigned &count_of_factors) 
{
    unsigned u=0;
    count_of_factors=0;
    
    //    cout << n << endl;
            
    
    for (unsigned i=0; i<primes.size() && primes[i]<=n; i++)
        while (!(n%primes[i])) 
        {
            n/=primes[i];
            u+=sum_of_digits(primes[i]);
            count_of_factors++;
        }

    if (n>1) 
    {
        u+=sum_of_digits(n);
        count_of_factors++;
    }
            
    return u;    
}

int main() 
{
    ifstream in("smith.in");

    build_primes();

    unsigned n;
    while (in>>n && n) 
    {
        bool found=false;
        do 
        {
            ++n;
            
            unsigned cof;
//            cout << "<< " << n << endl;
        
            unsigned sod=sum_of_digits(n);
//            cout << "||" << endl;
            unsigned sof=sum_of_factors(n, cof);
//            cout << ">>" << endl;
            
            found=(cof>1 && sof==sod);
            
        } while (!found);
        
        cout << n << endl;
    }
}

